﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.Model;

namespace addedRowBugReproduced
{
    public partial class Form1 : Form
    {
        StudentRepository sr = new StudentRepository();
        public Form1()
        {
            InitializeComponent();
            fpSpread1.DataSource = sr.Students;
            fpSpread1_Sheet1.DataAllowAddNew = true;
            fpSpread1_Sheet1.RowCount = 100;
        }

        private void deleteBtn_Click(object sender, EventArgs e)
        {
            deleteSelectedRows();
        }

        private void deleteSelectedRows()
        {
            // skipping the filtered-out rows
            // iterating through the rows bottom-up
            // to prevent from row indexes shifting-up when 
            // a row is deleted
            List<int> indices = new List<int>();
            CellRange cr = fpSpread1_Sheet1.GetSelection(0);
            if (cr == null)
            {
                return;
            }
            // collecting the indices of selected rows which are Not filtered-out (visible)
            for (int i = cr.Row; i < (cr.Row + cr.RowCount); i++)
            {
                if (fpSpread1_Sheet1.IsSelected(i, -1) == false)
                {
                    // if the row is not selected (just one cell)
                    // don't remove it
                    continue;
                }
                if (!indices.Contains(i))
                {
                    if (fpSpread1_Sheet1.RowFilter == null)
                    {
                        indices.Add(i);
                    }
                    else
                    {
                        if (!fpSpread1_Sheet1.RowFilter.IsRowFilteredOut(i))
                        {
                            indices.Add(i);
                        }
                    }
                }
            }
            // sorting the indices in order to iterate the rows bottom-up
            indices.Sort();
            for (int j = indices.Count - 1; j >= 0; j--)
            {
                fpSpread1_Sheet1.Rows[indices[j]].Remove();
            }

            fpSpread1_Sheet1.ClearSelection();
        }

        private void batchEditBtn_Click(object sender, EventArgs e)
        {
            foreach (var s in sr.students)
            {
                s.Grade -= 50;
            }
        }
    }
}
